org.apache.catalina.connector

## Class CoyoteOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - javax.servlet.ServletOutputStream
    - - org.apache.catalina.connector.CoyoteOutputStream

All Implemented Interfaces:
  Closeable, Flushable, AutoCloseable

    public class CoyoteOutputStream
    extends ServletOutputStream

Coyote implementation of the servlet output stream.

Author:
  Costin Manolache, Remy Maucherat

### Field Summary

Fields
`protected OutputBuffer` `ob`

### Constructor Summary

Constructors
`protected` `CoyoteOutputStream(OutputBuffer ob)`

### Method Summary

Methods
`protected Object` `clone()` Prevent cloning the facade.
`void` `close()`
`void` `flush()` Will send the buffer to the client.
`void` `write(byte[] b)`
`void` `write(byte[] b, int off, int len)`
`void` `write(int i)`

### Methods inherited from class javax.servlet.ServletOutputStream

`print, print, print, print, print, print, print, println, println, println, println, println, println, println, println`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### ob

    protected OutputBuffer ob

### Constructor Detail

#### CoyoteOutputStream

    protected CoyoteOutputStream(OutputBuffer ob)

### Method Detail

#### clone

    protected Object clone()
                    throws CloneNotSupportedException

Prevent cloning the facade.

Overrides:
  `clone` in class `Object`
Throws:
  `CloneNotSupportedException`

#### write

    public void write(int i)
               throws IOException

Specified by:
  `write` in class `OutputStream`
Throws:
  `IOException`

#### write

    public void write(byte[] b)
               throws IOException

Overrides:
  `write` in class `OutputStream`
Throws:
  `IOException`

#### write

    public void write(byte[] b,
             int off,
             int len)
               throws IOException

Overrides:
  `write` in class `OutputStream`
Throws:
  `IOException`

#### flush

    public void flush()
               throws IOException

Will send the buffer to the client.

Specified by:
  `flush` in interface `Flushable`
Overrides:
  `flush` in class `OutputStream`
Throws:
  `IOException`

#### close

    public void close()
               throws IOException

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Overrides:
  `close` in class `OutputStream`
Throws:
  `IOException`